/*
This script contains other engine functions which are used
directly for things like in-game battles and cutscenes.
*/

/*
/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\
map functions to add:

***Regular Map Engine***
-LoadMap => Cubes, sprites, tilesets, etc.
-CenterCamera
-GetYPoint/GetXPoint
-SetCameraX/SetCameraY
-RotateCamera(radians)
-RotateToAngle(radian)
-ClearQueue("draw"/"action")

-RotateToCube(radian)
****IMPORTANT****
the above function MUST rotate the camera so that the cube is visible
as well as shift the camera X and Y values so that it is centered.
*/


 /*-------------------------*\
|															|
|			Engine Functions				|
|															|
 \*-------------------------*/

var LastFrameTime = 0;
var DrawQueue = new Array();
var ActionQueue = new Array();
var FrameSec = 1000/50;
var TheFrames = 0;
var Foreground = true;
var Advancing = false;

var DrawIndex = new Array();
var TheString = "";

function StandardView()
{
	x_a_start = 3.14159/4;
	x_angle = 3.14159/4;
	y_angle = -3.14159/4;
	CDir = "d1";
	CameraX=-150;
	CameraY= -94;
	Scale = .75;
	RearrangeAngle();
}

var ExitMapEngine = false;
//the main map function


function NextFrame(input, autocenter)
{
	if (input == undefined)
	{
	input = true;
	}
var CurrentTime = 0;
var StringChar = 0;
ExitMapEngine = false;

	if (autocenter == true || autocenter == undefined)
	{
	x_a_start = 3.14159/4;
	x_angle = 3.14159/4;
	y_angle = -3.14159/4;
	CDir = "d1";
	CameraX=-150;
	CameraY= -94;
	Scale = .75;
	RearrangeAngle();
	}
	
	while(true)
	{
		CurrentTime = GetTime();

		while(GetTime() - LastFrameTime < FrameSec)
		{
		}

		if (CurrentTime - LastFrameTime < FrameSec*1.75)
		{
		//Draw this frame, otherwise skip drawing this frame
			DrawMap();
			if (DrawQueue[TheFrames] != undefined && DrawQueue[TheFrames] != "")
			{
			DoScript(DrawQueue[TheFrames]);
			DrawQueue[TheFrames] = undefined;
			}
			if (Foreground == true)
			{
			DrawForeground();
			}
		FlipScreen();
		}
		else
		{
			if (Frames/FrameUpdateRate == Math.floor(Frames/FrameUpdateRate))
			{
			AddFrameAll();
			}
		}
	
		//Actions
		if (ActionQueue[TheFrames] != undefined && ActionQueue[TheFrames] != "")
		{
			DoScript(ActionQueue[TheFrames]);
			ActionQueue[TheFrames] = undefined;
		}

		if (ExitMapEngine == true)
		{
		ExitMapEngine = false;
		return;
		}
		//check keyinputs
		if (TheFrames/4 == Math.floor(TheFrames/4) && input == true)
		{
			if (IsKeyPressed(KEY_ESCAPE))
			{
	//		GetKey();
	//		return;
			}
			if (IsKeyPressed(KEY_A))
			{
				Cameratempx = GetXPointCenter(GetScreenWidth()/2, GetScreenHeight()/2);
				Cameratempy = GetYPointCenter(GetScreenWidth()/2, GetScreenHeight()/2);
				Cameratempz = GetZPointCenter(GetScreenWidth()/2, GetScreenHeight()/2);
		
				ModX_x=ModX_x/Scale;
				ModX_y=ModX_y/Scale;
				ModY_x=ModY_x/Scale;
				ModY_y=ModY_y/Scale;
				Scale+= .05;

				if (Scale == 0)
				{
				Scale = 0.01;
				}

				ModX_x=ModX_x*Scale;
				ModX_y=ModX_y*Scale;
				ModY_x=ModY_x*Scale;
				ModY_y=ModY_y*Scale;
				ModZ_y=-1*ZFactor*Scale;
				CenterCamera(Cameratempx, Cameratempy, Cameratempz);
			}
			if (IsKeyPressed(KEY_Z))
			{
				Cameratempx = GetXPointCenter(GetScreenWidth()/2, GetScreenHeight()/2);
				Cameratempy = GetYPointCenter(GetScreenWidth()/2, GetScreenHeight()/2);
				Cameratempz = GetZPointCenter(GetScreenWidth()/2, GetScreenHeight()/2);

				ModX_x=ModX_x/Scale;
				ModX_y=ModX_y/Scale;
				ModY_x=ModY_x/Scale;
				ModY_y=ModY_y/Scale;
				Scale-= .05;
				if (Scale <= 0)
				{
				Scale = 0.01;
				}
	
				ModX_x=ModX_x*Scale;
				ModX_y=ModX_y*Scale;
				ModY_x=ModY_x*Scale;
				ModY_y=ModY_y*Scale;
				ModZ_y=-1*ZFactor*Scale;
				CenterCamera(Cameratempx, Cameratempy, Cameratempz);
			}
			if (IsKeyPressed(KEY_Q))
			{
				x_angle+= .1;
				y_angle+= .1;
				RearrangeAngle();
			}
			if (IsKeyPressed(KEY_W))
			{
				x_angle-= .1;
				y_angle-= .1;
				RearrangeAngle();
			}
			if (IsKeyPressed(KEY_D))
			{
				x_a_start += 3.1141569/180
				y_angle-=3.141569/180;
				x_angle+=3.141569/180;
				RearrangeAngle();
			}
			if (IsKeyPressed(KEY_C))
			{
				x_a_start -= 3.1141569/180
				y_angle+=3.141569/180;
				x_angle-=3.141569/180;
				RearrangeAngle();
			}
			if (IsKeyPressed(KEY_DOWN))
			{
				CameraY+= 8;
			}
			if (IsKeyPressed(KEY_UP))
			{
				CameraY-= 8;
			}
			if (IsKeyPressed(KEY_RIGHT))
			{
				CameraX+= 8;
			}
			if (IsKeyPressed(KEY_LEFT))
			{
				CameraX-= 8;
			}
			if (IsKeyPressed(KEY_SPACE))//Sets the camera to the default position
			{
				x_a_start = 3.14159/4;
				x_angle = 3.14159/4;
				y_angle = -3.14159/4;
				CDir = "d1";
				CameraX=-150;
				CameraY= -94;
				Scale = .75;
				RearrangeAngle();
			}
		}
	
		if (input == true)
		{
			while (AreKeysLeft())
			{
				if (GetKey() == KEY_ESCAPE)
				{
					EngineMenu();
				}
			}
		}


	LastFrameTime = CurrentTime;
	TheFrames++;
	Frames++;

		if (Advancing == true)
		{
		AdvancingFunc();
		}

	}
}

function ExitEngine()
{
ExitMapEngine = true;
} 

function SetMapDelayScript(frames, type, script)
{
	if (type == "draw")
	{
		if (DrawQueue[TheFrames+frames] != undefined)
		{
		DrawQueue[TheFrames+frames] += script;
		}
		else
		{
		DrawQueue[TheFrames+frames] = script;
		}
	}
	else
	{
		if (ActionQueue[TheFrames+frames] != undefined)
		{
		ActionQueue[TheFrames+frames] += script
		}
		else
		{
		ActionQueue[TheFrames+frames] = script;
		}
	}
}

var Window = LoadWindowStyle("main.rws");
var Port1 = LoadImage("Sprite1.png");

function DoScript(string)
{
var temp = CreateStringFromCode(92);
var tempf = OpenFile(".." + temp + "other" + temp + "temp.js");

tempf.write("/*", "*/"+string);
tempf.flush();
EvaluateScript('..' + temp + 'other' + temp + 'temp.js');
}

var tempy2 = 0;
var ForegroundBasic = false;
var TheString2 = "";

function DrawForeground()
{
	if (tempy2 == Math.floor(tempy2))
	{
	TheString += Texts[CurrentText].charAt(tempy2);
	}
	tempy2++;
	
	//This is where the status bar will be
	Window.drawWindow(5,3*GetScreenHeight()/4,GetScreenWidth()-10,GetScreenHeight()/4-5);
	Port1.blit(7, 3*GetScreenHeight()/4+2);
	font2.drawTextBox(45, 3*GetScreenHeight()/4+5,GetScreenWidth()-50,GetScreenHeight()/4-10,0,Names[CurrentName]);
	font.drawTextBox(45, 3*GetScreenHeight()/4+5,GetScreenWidth()-50,GetScreenHeight()/4-10,0,TheString);
	
	if (TheString.length == Texts[CurrentText].length)
	{
		if (IsKeyPressed(KEY_ENTER) || IsKeyPressed(KEY_SPACE))
		{
		Foreground = false;
		ForegroundBasic = false;
		TheString = "";
		TheString2 = "";
		tempy2 = 0;
			if (DoneTextScript != undefined && DoneTextScript != "")
			{
			DoScript(DoneTextScript);
			}
		DoneTextScript = "";
		}
	}

}

function AdvancingFunc()
{
	//This is the battle counter that activiates between turns
}

function EngineMenu()
{
Editor = false;
var selection = 0;
var max_selection = 2;
var CurrentTime = 0;

var Arrow = LoadImage("Arrow.png");
	while(true)
	{
		CurrentTime = GetTime();

		while(GetTime() - LastFrameTime < FrameSec)
		{
		}

		if (CurrentTime - LastFrameTime < FrameSec*1.75)
		{
		//Draw this frame, otherwise skip drawing this frame
			DrawMap();
			DrawForeground();
			Window.drawWindow(3*GetScreenWidth()/4, GetScreenHeight()/4, GetScreenWidth()/4 - 5, GetScreenHeight()/2 - 10);
			font.drawText(3*GetScreenWidth()/4+5, GetScreenHeight()/4+5, "Move");
			font.drawText(3*GetScreenWidth()/4+5, GetScreenHeight()/4+15, "Attack");
			font.drawText(3*GetScreenWidth()/4+5, GetScreenHeight()/4+25, "Cancel");
			Arrow.blit(3*GetScreenWidth()/4-10, GetScreenHeight()/4+2+selection*10);
		FlipScreen();
		}
		else
		{
			if (Frames/FrameUpdateRate == Math.floor(Frames/FrameUpdateRate))
			{
			AddFrameAll();
			}
		}

		Frames++;
		LastFrameTime = CurrentTime;

		while (AreKeysLeft())
		{
			switch(GetKey())
			{
				case KEY_ENTER:
				{
					if (selection == 0)
					{
					MoveMenu(1);
					}
					else if (selection == 1)
					{
					AttackMenu();
					}
					else if (selection == 2)
					{
					Exit();
					return;
					}				
				break;
				}
				case KEY_ESCAPE:
				{
				return;
				}
				case KEY_DOWN:
				{
					if (selection < max_selection)
					{
					selection++;
					}
					else
					{
					//beep!
					}
				break;
				}
				case KEY_UP:
				{
					if (selection > 0)
					{
					selection--;
					}
					else
					{
					//beep!
					}
				break;
				}
			}
		}
	}
}

function SetScale(num)
{
	Cameratempx = GetXPointCenter(GetScreenWidth()/2, GetScreenHeight()/2);
	Cameratempy = GetYPointCenter(GetScreenWidth()/2, GetScreenHeight()/2);
	Cameratempz = GetZPointCenter(GetScreenWidth()/2, GetScreenHeight()/2);
		
	ModX_x=ModX_x/(ScaleBase*Scale);
	ModX_y=ModX_y/(ScaleBase*Scale);
	ModY_x=ModY_x/(ScaleBase*Scale);
	ModY_y=ModY_y/(ScaleBase*Scale);
	Scale= num;

	if (Scale <= 0)
	{
	Scale = 0.01;
	}

	ModX_x=ModX_x*ScaleBase*Scale;
	ModX_y=ModX_y*ScaleBase*Scale;
	ModY_x=ModY_x*ScaleBase*Scale;
	ModY_y=ModY_y*ScaleBase*Scale;
	ModZ_y=-1*ZFactor*ScaleBase*Scale;
	CenterCamera(Cameratempx, Cameratempy, Cameratempz);
}

function RotateCamera(rads, queue, center, x,y,z,frames)
{
	if (rads <0)
	{
	var boo = false;
	}
	else
	{
	var boo = true;
	}

	if (frames!= undefined)
	{
	frames = 0.05;
	}
	else
	{
	frames = rads/frames;
	}

	var counter = 0;

	if (queue == false || queue == undefined)
	{
		while(true)
		{
			CurrentTime = GetTime();

			while(GetTime() - LastFrameTime < FrameSec)
			{
			}
				if (boo == true)
				{
					if (rads>=0)
						rads -= frames;
					else
						break;

					x_angle+= frames;
					y_angle+= frames;
					RearrangeAngle();
				}
				else
				{
					if (rads<=0)
						rads += frames;
					else
						break;

					x_angle-= frames;
					y_angle-= frames;
					RearrangeAngle();
				}

			if (center == true || center == undefined)
			{
			CenterCamera(x,y,z);
			}

			if (CurrentTime - LastFrameTime < FrameSec*1.75)
			{
			//Draw this frame, otherwise skip drawing this frame
				DrawMap();
				FlipScreen();
			}
			else
			{
				if (Frames/FrameUpdateRate == Math.floor(Frames/FrameUpdateRate))
				{
				AddFrameAll();
				}
			}

			Frames++;
			LastFrameTime = CurrentTime;
		}
	}
	else
	{
		while(true)
		{
			if (boo == true)
			{
				if (rads>=0)
					rads -= frames;
				else
					break;

				SetMapDelayScript(counter, "action", "x_angle+= "+frames+"; y_angle+= "+frames+"; RearrangeAngle();");

				if (center == true || center == undefined)
				{
				SetMapDelayScript(counter, "action", "CenterCamera("+ x + "," + y + "," + z+");");
				}
			}
			else
			{
				if (rads<=0)
					rads += frames;
				else
					break;

				SetMapDelayScript(counter, "action", "x_angle-= "+frames+"; y_angle-= "+frames+"; RearrangeAngle();");
				
				if (center == true || center == undefined)
				{
				SetMapDelayScript(counter, "action", "CenterCamera("+ x + "," + y + "," + z+");");
				}
			}
		counter++;
		}
	}
}

function CenterCameraTo(x,y,z, queue, speed)
{
//Center to the sprite
var CurrentTime = 0;
var temp_x = (ModX_x*(x) + ModY_x*(y))*TileSize-CameraX-GetScreenWidth()/2;
var temp_y = (ModX_y*(x) + ModY_y*(y) + ModZ_y*(z))*TileSize - CameraY - GetScreenHeight()/2;

/*
//This was used for debugging

DrawMap();
Line(GetScreenWidth()/2, GetScreenHeight()/2, GetScreenWidth()/2+temp_x, GetScreenHeight()/2+temp_y, CreateColor(0,0,255,255));
//Line(100, 100, 100+temp_x, 100, CreateColor(0,0,255,255));
//Line(100, 100, 100, 100+temp_y, CreateColor(0,0,255,255));
//Line(50+temp_x-GetScreenWidth()/2, 50, 50+temp_x-GetScreenWidth()/2, -temp_y+GetScreenHeight()/2, CreateColor(0,0,255,255));
Point(temp_x+GetScreenWidth()/2, temp_y+GetScreenHeight()/2, CreateColor(255,255,255,255));
FlipScreen();
GetKey();
*/

	if (speed == undefined)
	{
	speed = 3;
	}

var temp4 = Math.sqrt(temp_x*temp_x + temp_y*temp_y)/speed;

	if (temp4==0)
		return;

var temp_x = temp_x/temp4;
var temp_y = temp_y/temp4;


	if (queue == false || queue == undefined)
	{
		while(true)
		{
			CurrentTime = GetTime();

			while(GetTime() - LastFrameTime < FrameSec)
			{
			}
				//now use temp4 as a counter
				if (temp4>=0)
					temp4--;
				else
					break;

				CameraX+=temp_x;
				CameraY+=temp_y;

			if (CurrentTime - LastFrameTime < FrameSec*1.75)
			{
			//Draw this frame, otherwise skip drawing this frame
				DrawMap();
				FlipScreen();
			}
			else
			{
				if (Frames/FrameUpdateRate == Math.floor(Frames/FrameUpdateRate))
				{
				AddFrameAll();
				}
			}

			Frames++;
			LastFrameTime = CurrentTime;
		}
	CenterCamera(x, y, z);
	}
	else //queue this into the engine
	{
		for (i=0; i<= temp4; i++)
		{
		SetMapDelayScript(i, "action", "CameraX+="+temp_x+"; CameraY+="+temp_y+";");
		} 
		SetMapDelayScript(Math.floor(temp4)+1, "action", "CenterCamera("+x+","+y+","+z+");");
	}
}

function CenterCameraToV2(x,y,z, x2,y2,z2,queue, speed, rads)
{
//Center to the sprite
var CurrentTime = 0;
//var temp_x = (ModX_x*(x) + ModY_x*(y))*TileSize-CameraX-GetScreenWidth()/2;
//var temp_y = (ModX_y*(x) + ModY_y*(y) + ModZ_y*(z))*TileSize - CameraY - GetScreenHeight()/2;

var temp_x= x2-x;
var temp_y= y2-y;
var temp_z= z2-z;

/*
//This was used for debugging

DrawMap();
Line(GetScreenWidth()/2, GetScreenHeight()/2, GetScreenWidth()/2+temp_x, GetScreenHeight()/2+temp_y, CreateColor(0,0,255,255));
//Line(100, 100, 100+temp_x, 100, CreateColor(0,0,255,255));
//Line(100, 100, 100, 100+temp_y, CreateColor(0,0,255,255));
//Line(50+temp_x-GetScreenWidth()/2, 50, 50+temp_x-GetScreenWidth()/2, -temp_y+GetScreenHeight()/2, CreateColor(0,0,255,255));
Point(temp_x+GetScreenWidth()/2, temp_y+GetScreenHeight()/2, CreateColor(255,255,255,255));
FlipScreen();
GetKey();
*/

	if (speed == undefined)
	{
	speed = 3;
	}

var temp4 = TileSize*Math.sqrt(temp_x*temp_x + temp_y*temp_y + temp_z*temp_z)/speed;

	if (temp4==0)
		return;

var temp_x = temp_x/(temp4);
var temp_y = temp_y/(temp4);
var temp_z = temp_z/(temp4);

var Vi= 0;
	if (queue == false || queue == undefined)
	{
		while(true)
		{
			CurrentTime = GetTime();

			while(GetTime() - LastFrameTime < FrameSec)
			{
			}
				
				if (Vi<=temp4)
					Vi++;
				else
					break;

			CenterCamera(x+Vi*temp_x, y+Vi*temp_y, z+Vi*temp_z);
			if (rads != undefined)
			{
			RotateCamera(rads, false, false);
			}

			if (CurrentTime - LastFrameTime < FrameSec*1.75)
			{
			//Draw this frame, otherwise skip drawing this frame
				DrawMap();
				FlipScreen();
				GetKey();
			}
			else
			{
				if (Frames/FrameUpdateRate == Math.floor(Frames/FrameUpdateRate))
				{
				AddFrameAll();
				}
			}

			Frames++;
			LastFrameTime = CurrentTime;
		}
	CenterCamera(x2, y2, z2);
	}
	else //queue this into the engine
	{
		if (rads != undefined)
		{
		RotateCamera(rads, true, false, 0,0,0,temp4);
		}
		for (Vi=0; Vi<= temp4; Vi++)
		{
		SetMapDelayScript(Vi, "action", "CenterCamera("+(x+Vi*temp_x)+","+(y+Vi*temp_y)+","+(z+Vi*temp_z)+");");

		} 
		SetMapDelayScript(Math.floor(temp4)+1, "action", "CenterCamera("+x2+","+y2+","+z2+");");
	}
}

function MoveMenu(the_sprite)
{
//var selection = 0;
//var max_selection = 2;
//var Arrow = LoadImage("Arrow.png");

CenterCameraTo(Cube[Sprite[the_sprite].cube].x+.5,Cube[Sprite[the_sprite].cube].y+.5,Cube[Sprite[the_sprite].cube].z+Cube[Sprite[the_sprite].cube].height);
//Start the "menu"
	while(true)
	{
		CurrentTime = GetTime();

		while(GetTime() - LastFrameTime < FrameSec)
		{
		}

		if (CurrentTime - LastFrameTime < FrameSec*1.75)
		{
		//Draw this frame, otherwise skip drawing this frame
			DrawMap();
			FlipScreen();
		}
		else
		{
			if (Frames/FrameUpdateRate == Math.floor(Frames/FrameUpdateRate))
			{
			AddFrameAll();
			}
		}

		Frames++;
		LastFrameTime = CurrentTime;


		if (Frames/4 == Math.floor(Frames/4))
		{
			if (IsKeyPressed(KEY_ESCAPE))
			{
	//		GetKey();
	//		return;
			}
			if (IsKeyPressed(KEY_A))
			{
				Cameratempx = GetXPointCenter(GetScreenWidth()/2, GetScreenHeight()/2);
				Cameratempy = GetYPointCenter(GetScreenWidth()/2, GetScreenHeight()/2);
				Cameratempz = GetZPointCenter(GetScreenWidth()/2, GetScreenHeight()/2);
		
				ModX_x=ModX_x/Scale;
				ModX_y=ModX_y/Scale;
				ModY_x=ModY_x/Scale;
				ModY_y=ModY_y/Scale;
				Scale+= .05;

				if (Scale == 0)
				{
				Scale = 0.01;
				}

				ModX_x=ModX_x*Scale;
				ModX_y=ModX_y*Scale;
				ModY_x=ModY_x*Scale;
				ModY_y=ModY_y*Scale;
				ModZ_y=-1*ZFactor*Scale;
				CenterCamera(Cameratempx, Cameratempy, Cameratempz);
			}
			if (IsKeyPressed(KEY_Z))
			{
				Cameratempx = GetXPointCenter(GetScreenWidth()/2, GetScreenHeight()/2);
				Cameratempy = GetYPointCenter(GetScreenWidth()/2, GetScreenHeight()/2);
				Cameratempz = GetZPointCenter(GetScreenWidth()/2, GetScreenHeight()/2);

				ModX_x=ModX_x/Scale;
				ModX_y=ModX_y/Scale;
				ModY_x=ModY_x/Scale;
				ModY_y=ModY_y/Scale;
				Scale-= .05;
				if (Scale <= 0)
				{
				Scale = 0.01;
				}
	
				ModX_x=ModX_x*Scale;
				ModX_y=ModX_y*Scale;
				ModY_x=ModY_x*Scale;
				ModY_y=ModY_y*Scale;
				ModZ_y=-1*ZFactor*Scale;
				CenterCamera(Cameratempx, Cameratempy, Cameratempz);
			}
			if (IsKeyPressed(KEY_Q))
			{
				x_angle+= .1;
				y_angle+= .1;
				RearrangeAngle();
				CenterCamera(Cube[Sprite[the_sprite].cube].x+.5,Cube[Sprite[the_sprite].cube].y+.5,Cube[Sprite[the_sprite].cube].z+Cube[Sprite[the_sprite].cube].height)
			}
			if (IsKeyPressed(KEY_W))
			{
				x_angle-= .1;
				y_angle-= .1;
				RearrangeAngle();
				CenterCamera(Cube[Sprite[the_sprite].cube].x+.5,Cube[Sprite[the_sprite].cube].y+.5,Cube[Sprite[the_sprite].cube].z+Cube[Sprite[the_sprite].cube].height)
			}
		}

		while (AreKeysLeft())
		{
			switch(GetKey())
			{
				case KEY_RIGHT:
				{
					if (CDir == "d1")
						MoveSprite(1, "se", true);
					else if (CDir == "d2")
						MoveSprite(1, "ne", true);
					else if (CDir == "d3")
						MoveSprite(1, "nw", true);
					else if (CDir == "d4")
						MoveSprite(1, "sw", true);
				break;
				}
				case KEY_LEFT:
				{
					if (CDir == "d1")
						MoveSprite(1, "nw", true);
					else if (CDir == "d2")
						MoveSprite(1, "sw", true);
					else if (CDir == "d3")
						MoveSprite(1, "se", true);
					else if (CDir == "d4")
						MoveSprite(1, "ne", true);
				break;
				}
				case KEY_DOWN:
				{
					if (CDir == "d1")
						MoveSprite(1, "sw", true);
					else if (CDir == "d2")
						MoveSprite(1, "se", true);
					else if (CDir == "d3")
						MoveSprite(1, "ne", true);
					else if (CDir == "d4")
						MoveSprite(1, "nw", true);
				break;
				}
				case KEY_UP:
				{
					if (CDir == "d1")
						MoveSprite(1, "ne", true);
					else if (CDir == "d2")
						MoveSprite(1, "nw", true);
					else if (CDir == "d3")
						MoveSprite(1, "sw", true);
					else if (CDir == "d4")
						MoveSprite(1, "se", true);
				break;
				}
				case KEY_ESCAPE:
				{
				return;
				}
				case KEY_ENTER:
				{
				return;
				}
			}
		}
	}
}


function AttackMenu()
{
	TheString = "";
	tempy2=0;
	CurrentText++;
}


//Finish this function
function ConvertTexts()
{
var temptext = "";
var temptext2 = "";
	for (i=0; i<10000; i++)
	{
		if (CurrentText[i] != undefined && CurrentText[i] != "")
		{
			for (j=0; j<100; j++)
			{
				if (CurrentText[i].charAt(j) != " ")
				{
				}
			}
		}
	temptext = "";
	}
}